/****************************************************************************
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2015                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef SCOUT_PATTERNS_GEN_H
#define SCOUT_PATTERNS_GEN_H


namespace scout
{

//--- Constants -------------------------------------------------------------

const long PAT_NONE                           =  -1;
const long PAT_TIME                           =   0;
const long PAT_VISITS                         =   1;
const long PAT_EXECUTION                      =   2;
const long PAT_OVERHEAD                       =   3;
const long PAT_ASYNC                          =   4;
const long PAT_MPI                            =   5;
const long PAT_MPI_SYNCHRONIZATION            =   6;
const long PAT_MPI_COMMUNICATION              =   7;
const long PAT_MPI_IO                         =   8;
const long PAT_MPI_IO_COLLECTIVE              =   9;
const long PAT_MPI_INIT_EXIT                  =  10;
const long PAT_MPI_FINALIZE_WAIT              =  11;
const long PAT_MPI_INIT_COMPLETION            =  12;
const long PAT_MPI_SYNC_COLLECTIVE            =  13;
const long PAT_MPI_BARRIER_WAIT               =  14;
const long PAT_MPI_BARRIER_COMPLETION         =  15;
const long PAT_MPI_POINT2POINT                =  16;
const long PAT_MPI_LATESENDER                 =  17;
const long PAT_MPI_LATESENDER_WO              =  18;
const long PAT_MPI_LSWO_DIFFERENT             =  19;
const long PAT_MPI_LSWO_SAME                  =  20;
const long PAT_MPI_LATERECEIVER               =  21;
const long PAT_MPI_COLLECTIVE                 =  22;
const long PAT_MPI_EARLYREDUCE                =  23;
const long PAT_MPI_EARLYSCAN                  =  24;
const long PAT_MPI_LATEBROADCAST              =  25;
const long PAT_MPI_WAIT_NXN                   =  26;
const long PAT_MPI_NXN_COMPLETION             =  27;
const long PAT_OMP_IDLE_THREADS               =  28;
const long PAT_OMP_LIMITED_PARALLELISM        =  29;
const long PAT_OMP_TIME                       =  30;
const long PAT_OMP_FLUSH                      =  31;
const long PAT_OMP_MANAGEMENT                 =  32;
const long PAT_OMP_FORK                       =  33;
const long PAT_OMP_SYNCHRONIZATION            =  34;
const long PAT_OMP_BARRIER                    =  35;
const long PAT_OMP_EBARRIER                   =  36;
const long PAT_OMP_EBARRIER_WAIT              =  37;
const long PAT_OMP_IBARRIER                   =  38;
const long PAT_OMP_IBARRIER_WAIT              =  39;
const long PAT_OMP_CRITICAL                   =  40;
const long PAT_OMP_LOCK_API                   =  41;
const long PAT_OMP_ORDERED                    =  42;
const long PAT_OMP_LOCK_CONTENTION_API        =  43;
const long PAT_OMP_LOCK_CONTENTION_CRITICAL   =  44;
const long PAT_PTHREAD_TIME                   =  45;
const long PAT_PTHREAD_MANAGEMENT             =  46;
const long PAT_PTHREAD_SYNCHRONIZATION        =  47;
const long PAT_PTHREAD_LOCK_API               =  48;
const long PAT_PTHREAD_CONDITIONAL            =  49;
const long PAT_PTHREAD_LOCK_CONTENTION_MUTEX_LOCK =  50;
const long PAT_PTHREAD_LOCK_CONTENTION_CONDITIONAL =  51;
const long PAT_THREAD_LOCK_CONTENTION         =  52;
const long PAT_SYNCS                          =  53;
const long PAT_SYNCS_P2P                      =  54;
const long PAT_SYNCS_SEND                     =  55;
const long PAT_SYNCS_RECV                     =  56;
const long PAT_SYNCS_COLL                     =  57;
const long PAT_COMMS                          =  58;
const long PAT_COMMS_P2P                      =  59;
const long PAT_COMMS_SEND                     =  60;
const long PAT_COMMS_RECV                     =  61;
const long PAT_COMMS_COLL                     =  62;
const long PAT_COMMS_CXCH                     =  63;
const long PAT_COMMS_CSRC                     =  64;
const long PAT_COMMS_CDST                     =  65;
const long PAT_BYTES                          =  66;
const long PAT_BYTES_P2P                      =  67;
const long PAT_BYTES_SENT                     =  68;
const long PAT_BYTES_RCVD                     =  69;
const long PAT_BYTES_COLL                     =  70;
const long PAT_BYTES_COUT                     =  71;
const long PAT_BYTES_CIN                      =  72;
const long PAT_BYTES_RMA                      =  73;
const long PAT_BYTES_GET                      =  74;
const long PAT_BYTES_PUT                      =  75;
const long PAT_MPI_CLS_COUNT                  =  76;
const long PAT_MPI_CLSWO_COUNT                =  77;
const long PAT_MPI_CLR_COUNT                  =  78;
const long PAT_MPI_SLS_COUNT                  =  79;
const long PAT_MPI_SLSWO_COUNT                =  80;
const long PAT_MPI_SLR_COUNT                  =  81;
const long PAT_MPI_FILE_OPS                   =  82;
const long PAT_MPI_FILE_IOPS                  =  83;
const long PAT_MPI_FILE_IROPS                 =  84;
const long PAT_MPI_FILE_IWOPS                 =  85;
const long PAT_MPI_FILE_COPS                  =  86;
const long PAT_MPI_FILE_CROPS                 =  87;
const long PAT_MPI_FILE_CWOPS                 =  88;
const long PAT_MPI_FILE_BYTES                 =  89;
const long PAT_MPI_FILE_IBYTES                =  90;
const long PAT_MPI_FILE_IRBYTES               =  91;
const long PAT_MPI_FILE_IWBYTES               =  92;
const long PAT_MPI_FILE_CBYTES                =  93;
const long PAT_MPI_FILE_CRBYTES               =  94;
const long PAT_MPI_FILE_CWBYTES               =  95;
const long PAT_MPI_RMA_SYNCHRONIZATION        =  96;
const long PAT_MPI_RMA_COMMUNICATION          =  97;
const long PAT_MPI_RMA_SYNC_LATE_POST         =  98;
const long PAT_MPI_RMA_COMM_LATE_POST         =  99;
const long PAT_MPI_RMA_EARLY_WAIT             = 100;
const long PAT_MPI_RMA_LATE_COMPLETE          = 101;
const long PAT_MPI_RMA_WAIT_AT_CREATE         = 102;
const long PAT_MPI_RMA_WAIT_AT_FREE           = 103;
const long PAT_MPI_RMA_WAIT_AT_FENCE          = 104;
const long PAT_MPI_RMA_EARLY_FENCE            = 105;
const long PAT_MPI_RMA_PAIRSYNC_COUNT         = 106;
const long PAT_MPI_RMA_PAIRSYNC_UNNEEDED_COUNT = 107;
const long PAT_MPI_RMA_SYNC_LOCK_COMPETITION  = 108;
const long PAT_MPI_RMA_COMM_LOCK_COMPETITION  = 109;
const long PAT_MPI_RMA_COMM_WAIT_FOR_PROGRESS = 110;
const long PAT_MPI_RMA_SYNC_WAIT_FOR_PROGRESS = 111;
const long PAT_IMBALANCE                      = 112;
const long PAT_IMBALANCE_ABOVE                = 113;
const long PAT_IMBALANCE_ABOVE_SINGLE         = 114;
const long PAT_IMBALANCE_BELOW                = 115;
const long PAT_IMBALANCE_BELOW_BYPASS         = 116;
const long PAT_IMBALANCE_BELOW_SINGULARITY    = 117;
const long PAT_STATISTICS                     = 118;
const long PAT_CRITICAL_PATH                  = 119;
const long PAT_PERFORMANCE_IMPACT             = 120;
const long PAT_CRITICAL_PATH_ACTIVITIES       = 121;
const long PAT_CRITICAL_IMBALANCE_IMPACT      = 122;
const long PAT_INTRA_PARTITION_IMBALANCE      = 123;
const long PAT_INTER_PARTITION_IMBALANCE      = 124;
const long PAT_NON_CRITICAL_PATH_ACTIVITIES   = 125;
const long PAT_CRITICAL_PATH_IMBALANCE        = 126;
const long PAT_DELAY                          = 127;
const long PAT_DELAY_MPI                      = 128;
const long PAT_DELAY_P2P                      = 129;
const long PAT_DELAY_LATESENDER_AGGREGATE     = 130;
const long PAT_DELAY_LATESENDER               = 131;
const long PAT_DELAY_LATESENDER_LONGTERM      = 132;
const long PAT_DELAY_LATERECEIVER_AGGREGATE   = 133;
const long PAT_DELAY_LATERECEIVER             = 134;
const long PAT_DELAY_LATERECEIVER_LONGTERM    = 135;
const long PAT_DELAY_COLLECTIVE               = 136;
const long PAT_DELAY_BARRIER_AGGREGATE        = 137;
const long PAT_DELAY_BARRIER                  = 138;
const long PAT_DELAY_BARRIER_LONGTERM         = 139;
const long PAT_DELAY_N2N_AGGREGATE            = 140;
const long PAT_DELAY_N2N                      = 141;
const long PAT_DELAY_N2N_LONGTERM             = 142;
const long PAT_DELAY_12N_AGGREGATE            = 143;
const long PAT_DELAY_12N                      = 144;
const long PAT_DELAY_12N_LONGTERM             = 145;
const long PAT_DELAY_OMP                      = 146;
const long PAT_DELAY_OMPIDLE_AGGREGATE        = 147;
const long PAT_DELAY_OMPIDLE                  = 148;
const long PAT_DELAY_OMPIDLE_LONGTERM         = 149;
const long PAT_DELAY_OMPBARRIER_AGGREGATE     = 150;
const long PAT_DELAY_OMPBARRIER               = 151;
const long PAT_DELAY_OMPBARRIER_LONGTERM      = 152;
const long PAT_MPI_WAIT_DI                    = 153;
const long PAT_MPI_WAIT_DIRECT                = 154;
const long PAT_MPI_WAIT_DIRECT_P2P            = 155;
const long PAT_MPI_WAIT_DIRECT_LATESENDER     = 156;
const long PAT_MPI_WAIT_DIRECT_LATERECEIVER   = 157;
const long PAT_MPI_WAIT_DIRECT_COLL           = 158;
const long PAT_MPI_WAIT_INDIRECT              = 159;
const long PAT_MPI_WAIT_INDIRECT_P2P          = 160;
const long PAT_MPI_WAIT_INDIRECT_LATESENDER   = 161;
const long PAT_MPI_WAIT_INDIRECT_LATERECEIVER = 162;
const long PAT_MPI_WAIT_INDIRECT_COLL         = 163;
const long PAT_MPI_WAIT_PT                    = 164;
const long PAT_MPI_WAIT_PROPAGATING           = 165;
const long PAT_MPI_WAIT_TERMINAL              = 166;


//--- Forward declarations --------------------------------------------------

class AnalyzeTask;


//--- Function prototypes ---------------------------------------------------

void create_patterns(AnalyzeTask* analyzer);


}   /* namespace scout */


#endif   /* !SCOUT_PATTERNS_GEN_H */
